import { select, range, scaleOrdinal } from "d3"

const colorScale = scaleOrdinal()
	.domain(['apple', 'lemon'])
	.range(['#c11d1d', '#e4c14d']);
const radiusScale = scaleOrdinal()
	.domain(['apple', 'lemon'])
	.range([50, 30]);

const xPosition = (d, i) => i * 120+60

export const fruitBowl = (selection, props) => {
  const { fruits, height } = props;
  
  const bowl = selection.selectAll('rect');
  const newBowl = bowl.data([null]).enter().append('rect')
    .attr('y', 100)
    .attr('height', 350)
    .attr('rx', 350/1.5)
  	.attr('width', fruits.length * 120)
  	.merge(bowl).transition().duration(1100)
  		.attr('width', fruits.length * 120)
  
  const groups = selection.selectAll('g').data(fruits, d => d.id);
 	const groupsEnter = groups.enter().append('g');
  groupsEnter
  	.attr('transform', (d, i) => 
  		`translate(${i * 120+60}, ${height / 2})`)
    .merge(groups)
    .transition().duration(1000)
  		.attr('transform', (d, i) => 
            `translate(${i * 120+60}, ${height / 2})`);
  const groupExit = groups.exit();
  
    
  groupsEnter.append('circle')
    .merge(groups.select('circle'))
  		.attr('fill', d => colorScale(d.type))
  		.transition().duration(1000)
    		.attr('r',  d => radiusScale(d.type));
	
  groupsEnter.append('text')
    .merge(groups.select('text'))
  		.text(d => d.type)
      .attr('y', 120)
  
	groupExit.select('circle')
    .transition().duration(700)
  		.attr('r', 0)
    .remove()
  groupExit.select('text').remove()
}